#define MAXSTACK		50
#define TRUE			1
#define FALSE			0
#define ZERO                    0
#define TAMANHO_LINHA           80
#define TAMANHO_INT		4
#define TAMANHO_NOME	        11
#define TAMANHO_FLOAT           8
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

// pilha21.cpp
// pilha com implementacao por adjacencia

struct dataarea {
	int numero;
	char nome[10];
	float salario;
	} ;


struct stack {
	int top;
	struct dataarea item[MAXSTACK];
	};

FILE *p;
int tamanho;
struct stack s;

int empty(struct stack);
void stacktop(struct stack *, struct dataarea *);
int pop(struct stack *,struct dataarea *);
int push(struct stack *,struct dataarea);
void imprimir_pilha(struct stack);
void imprimir_dado(struct dataarea);

/*****************************************************************/

int main()
{
struct dataarea currarea;

int underflow, overflow;
char transacao;
char linha[TAMANHO_LINHA];
char s_numero[TAMANHO_INT + 1];
char s_salario[TAMANHO_FLOAT + 1];
int i;
p=fopen("D:\\OldC\\Ferraz\\EDII\\ProgCPP\\DADOS\\arq9502.dat","r");
//p=fopen("arq9502.dat","r");
//clrscr();
tamanho = sizeof(struct dataarea);
s.top = -1;
overflow = FALSE;
underflow = FALSE;

while (fgets(linha,TAMANHO_LINHA,p) != NULL)
  {       /*  extracao dos dados da linha lida   */
   transacao = linha[0];

   for (i = 0;i <= TAMANHO_INT;i++)
	   s_numero[i] = linha[i + 1];
   s_numero[TAMANHO_INT] = 0;
   currarea.numero = atoi(s_numero);

   for (i = 0;i <= TAMANHO_NOME;i++)
	   currarea.nome[i] = linha[i + TAMANHO_INT + 1];
   currarea.nome[TAMANHO_NOME] = 0;

   for (i = 0;i <= TAMANHO_FLOAT;i++)
	   s_salario[i] = linha[i + TAMANHO_INT + TAMANHO_NOME + 1];
   s_salario[TAMANHO_FLOAT] = 0;
       currarea.salario = atof(s_salario);

if (transacao !='f'){

printf("\tTransacao: %c\n",transacao);
if (transacao == 'i') {
  overflow = push(&s,currarea);

  if (overflow) {
     printf("%s","stack overflow");

     } /* end if (overflow)  */
    else
     printf("Registro incluido-> ");
		   imprimir_dado(currarea);
    } /* end "then" do if(transacao =='i')   */
  else
    if (transacao == 'e') {
       underflow = pop(&s,&currarea);

       if (underflow) {
	  printf("%s","Pilha vazia\n");

	  } /* end if (underflow)  */
	 else {
	  printf("Registro excluido-> ");
	  imprimir_dado(currarea);
	  }
	} /* end "then" do if (transacao == 'e')  */
       else
	 printf("%s","transacao diferente de 'i', 'e' ou 'f'\n");

getch();

 }
 }
 fclose(p);
 imprimir_pilha(s);
 getch();
 }

/*****************************************************************/

int empty(struct stack ps)
 {
 if (ps.top == -1)
     return(TRUE);
   else
     return(FALSE);
 }  /*  end empty  */

/*****************************************************************/

int pop(struct stack *ps,struct dataarea *pa)
 {
 if (empty(*ps)) {
    return(TRUE);
    }  /* end if  */
 *pa = ps->item[ps->top--];
 return(FALSE);
 }  /* end pop  */

/*****************************************************************/

int push(struct stack *ps,struct dataarea pa)
{
if (ps->top == MAXSTACK-1) {
    return(TRUE);
    }      /*  end if  */
  else {
	ps->item[++(ps->top)] = pa;
	return(FALSE);
	}
}  /* end push  */

/*****************************************************************/

void stacktop(struct stack *ps, struct dataarea *pa)
{
 if (empty(*ps)) {
    printf("%s","Pilha vazia\n");
    return;
    }
   else {
    *pa = ps->item[ps->top];
    return;
    }
 }  /*  end stacktop  */

/*****************************************************************/

void imprimir_pilha(struct stack pp)
 {
 int i;

 if (empty(pp)) {
    printf("Pilha vazia. Nada a imprimir\n");
    }
   else {
    printf("\n\n\t\tPilha Final\n\n");
    i = pp.top;
    while (i != -1) {
      imprimir_dado(pp.item[i]);
      i--;
     }
    }
}  /* end imprimir_pilha  */

/*****************************************************************/

void imprimir_dado(struct dataarea pa)
{
 printf("numero: %2d\tnome: %.10s\tsalario: %10.2f\n",
		  pa.numero,pa.nome,pa.salario);
}
